<?php
// Software released under the General Public License (version 2 or later), available at
// http://www.gnu.org/copyleft/gpl.html
//********************************************************************************
/**
Interface to be implemented by yurt parts

@version  1.0
@license  GPL
@author   <a href='http://www.tig12.net'>Thierry Graff</a>
@php      PHP5
@history  2007.06.12, 00h40 : Creation
********************************************************************************/

abstract class YurtPart{
  
  /** The yurt containing this yurt part **/
  protected $yurt;
  
  /**
    @return A XHTML string exposing the results of this yurt part.
    @param $yurt The yurt containing this yurt part.
  **/
  public function __construct(&$yurt){
    $this->yurt = $yurt;
  }
  
  /**
    @return A XHTML string exposing the results of this yurt part.
  **/
  public abstract function toHtml($params = '');
  
  //**********************************************************************************
  //                            Static methods
  //**********************************************************************************
  /**
    Formats a number in a string
    Ex : converts 18.39 to "18 m 39"
    @m $nb Number of meters
  **/
  public static function formatMeters($nb){
    $m = floor($nb);
    $cm = $nb - $m;
    if($cm == 0) return $m . ' m';
    return $m . ' m ' . round($cm, 2) * 100;
  }

  /**
    Converts a number expressed in meters to centimeters
    @param $nb Number of meters
    @param $precision Nb of decimals in the result
  **/
  public static function m2cm($nb, $precision=1){ return round($nb * 100, $precision); }
}// end class YurtPart

?>