<?php 
// Software released under the General Public License (version 2 or later), available at
// http://www.gnu.org/copyleft/gpl.html
/****************************************************************************************
    Utilities to parse .ini files containing C-like comments (single and multi line)
    
    @version    1.0
    @license    GPL
    @author     Thierry Graff
    @weblink    http://www.tig12.net
    @history 2007.06.12 : Creation
****************************************************************************************/


    
//***************************************************
/** 
    Works like php function parse_ini_file(), but tolerates also C-like comments (single and multi line)
**/
function parse_ini_file2($fileName){
    return parse_ini_string2(file_get_contents($fileName));
}// end parse_ini_file2
            

//***************************************************
/** 
    Works like php function parse_ini_string(), but tolerates also C-like comments (single and multi line)
**/
function parse_ini_string2($str){
    $str = removeCLikeComments($str);
    $tmpfile = '/tmp/tmp_parseinifile2'; // must be writable
    file_put_contents($tmpfile, $str);
    $array = parse_ini_file($tmpfile, true);
    unlink($tmpfile);
    return $array;
}// end parse_ini_file2
            

//***************************************************
// Removes classical "/* ... **/" and "//" comments 
function removeCLikeComments($str){
    // remove "/* ... **/" comments
    $str = preg_replace("/\/\*.*?\*\//s", '', $str);
    // remove "//" comments
    $str = preg_replace("/\/\/.*/", '', $str);
    return $str;
} // end removeCLikeComments
