<?php
// Software released under the General Public License (version 2 or later), available at
// http://www.gnu.org/copyleft/gpl.html
//********************************************************************************
/**
Image d'un &eacute;l&eacute;ment de plancher ou tableau avec les dimensions.

@version  1.0
@license  GPL
@author   <a href='http://www.tig12.net'>Thierry Graff</a>
@php      PHP5
@history 2007.03.13 : Creation
@history 2007.06.12 : transformation to a class
****************************************************************************************/
require_once(dirname(dirname(__FILE__)) . '/YurtPart.php');

class Floor extends YurtPart{
  
  /**
    @param $params can be 'image' : returns a plan in an image
                       or 'table' : returns a table with the data
  **/
  public function toHtml($params=''){
//echo "<pre>"; print_r($this->data); echo "</pre>";
    // Variables impportees
    $D = $this->yurt->getConfig('general', 'D'); // diametre de la yourte, en m
    //
    // Valeurs &agrave; fixer &agrave; cette etape
    $R1 = $this->yurt->getConfig('floor', 'R1'); // rayon du trou central, en cm
    $n = $this->yurt->getConfig('floor', 'n'); // nb de divisions du cercle
    $pm = $this->yurt->getConfig('floor', 'pm'); // Portee max (pour EF), en cm
    //
    // Variables pour le dessin de l'image
    $scale = $this->yurt->getConfig('floor', 'scale'); // facteur d'echelle ; 1 cm <--> $scale px
    $th = 6; // epaisseur des chevrons, en pixels - doit etre pair
    // espaces entre la figure et le bord de l'image, en pixels
    $hgap1 = $this->yurt->getConfig('floor', 'hgap1');
    $hgap2 = $this->yurt->getConfig('floor', 'hgap2');
    $vgap1 = $this->yurt->getConfig('floor', 'vgap1');
    $vgap2 = $this->yurt->getConfig('floor', 'vgap2');
    $fs = $this->yurt->getConfig('floor', 'fs'); // font size pour les lettres
    $fs2 = $this->yurt->getConfig('floor', 'fs2'); // font size pour les indices
    $fs3 = $this->yurt->getConfig('floor', 'fs3'); // font size pour les mesures
    $font = $this->yurt->getConfig('general', 'ROOT_DIR') . '/fonts/ARIAL.TTF';
    $font2 = $this->yurt->getConfig('general', 'ROOT_DIR') . '/fonts/SYMBOL.TTF';
    $pointSize = $this->yurt->getConfig('floor', 'pointSize');
    
    // Calculs de base
    $R = $D * 100 / 2;
    $R *= $scale;
    $D = 2 * $R;
    $R1 *= $scale;
    $th *= $scale;
    $pm *= $scale;
    //
    $alpha = M_PI / $n;
    $alpha_deg = 180 / $n;
    $AB_round = 2 * $R * $alpha;
    $AB = 2 * $R * sin($alpha);
    $OH1 = $R * cos($alpha);
    $H1I = $R * (1 - cos($alpha));
    $OE = $R * $pm / $AB;
    $OH2 = $OE * cos($alpha);
    // Calcul supplementaires
    $OC = $R1;
    $EA = $R - $OE;
    $CA = $R - $R1;
    $CE = $CA - $EA;
    $OH3 = $R1 * cos($alpha);
    $H2H3 = $CE * cos($alpha);
    $H2H1 = $EA * cos($alpha);
    $H2I = $H2H1 + $H1I;
    $EF = $pm;
    $CD = 2 * $R1 * sin($alpha);
    
    if($params == 'table'){
      $res = '';
      $res.= "<table>\n";
      $res.= "<tr>\n";
      $res .= "<td>\n";
        $res .= "OC = " . round($OC, 1) . " cm\n";
        $res .= "<br/>CE = " . round($CE, 1) . " cm\n";
        $res .= "<br/>EA = " . round($EA, 1) . " cm\n";
        $res .= "<br/>CA = " . round($CA, 1) . " cm\n";
      $res .= "</td>\n";
      $res .= "<td>\n";
        $res .= "CD = " . round($CD, 1) . " cm\n";
        $res .= "<br/>EF = " . round($EF, 1) . " cm\n";
        $res .= "<br/>AB = " . round($AB, 1) . " cm\n";
      $res .= "</td>\n";
      $res .= "<td>\n";
        $res .= "OH<sub>2</sub> = " . round($OH2, 1) . " cm\n";
        $res .= "<br/>H<sub>2</sub>H<sub>3</sub> = " . round($H2H3, 1) . " cm\n";
//        $res .= "<br/>H<sub>3</sub>H<sub>1</sub> = " . round($H3H1, 1) . " cm\n";  ////////// BUG : a calculer
//        $res .= "<br/>H<sub>3</sub>I = " . round($H3I, 1) . " cm\n";  ////////// BUG : a calculer
        $res .= "<br/>H<sub>1</sub>I = " . round($H1I, 1) . " cm\n";
      $res .= "</td>\n";
      $res.= "</tr>\n";
      $res.= "</table>\n";
      return $res;
    }
    
    else if($params == 'image'){
      // Dimensions de l'image
      $w = $R + $hgap1 + $hgap2;
      $h = $R * cos($alpha) + $vgap1 + $vgap2;
//echo "<br/>$R - $hgap2";
      // Coordonnees des points
      $xO = $hgap1;
      $yO = $h/2;
      $xI = $xO + $R;
      $yI = $h/2;
      $xA = $xO + $R*cos($alpha);
      $yA = $yO - $R*sin($alpha);
      $xB = $xO + $R*cos($alpha);
      $yB = $yO + $R*sin($alpha);
      $xC = $xO + $R1*cos($alpha);
      $yC = $yO - $R1*sin($alpha);
      $xD = $xO + $R1*cos($alpha);
      $yD = $yO + $R1*sin($alpha);
      $xE = $xO + $OE*cos($alpha);
      $yE = $yO - $OE*sin($alpha);
      $xF = $xO + $OE*cos($alpha);
      $yF = $yO + $OE*sin($alpha);
      $xH1 = $xA;
      $yH1 = $yO;
      $xH3 = $xD;
      $yH3 = $yO;
      $xH2 = $xF;
      $yH2 = $yO;
      
      // *** Fabrication de l'image ***
      $img = imagecreatetruecolor($w, $h);
      $white = imagecolorallocate($img, 255, 255, 255);
      $grey = imagecolorallocate($img, 128, 128, 128);
      $black = imagecolorallocate($img, 0, 0, 0);
      $bgcolor = imagecolorallocate($img, 246, 226, 241); // couleur du plancher
      
      // fond
      imagefilledrectangle($img, 0, 0, $w, $h, $white); // met fond blanc
      imagefilledarc($img, $xO, $yO, $D, $D, 360-$alpha_deg, 360, $bgcolor, IMG_ARC_PIE);
      imagefilledarc($img, $xO, $yO, $D, $D, 0, $alpha_deg, $bgcolor, IMG_ARC_PIE);
      $values = array(
        $xO,$yO,
        $xC,$yC,
        $xD,$yD
      );
      imagefilledpolygon($img, $values, 3, $white);
      
      // Dessin des lignes et arcs
      imageLine($img, $xC, $yC, $xA, $yA, $black); // CA
      imageLine($img, $xD, $yD, $xB, $yB, $black); // DB
      imageLine($img, $xA, $yA, $xB, $yB, $black); // AB
      imageLine($img, $xC, $yC, $xD, $yD, $black); // CD
      imageLine($img, $xE, $yE, $xF, $yF, $black); // EF
      // arc AB
      imageArc($img, $xO, $yO, $D, $D, 360-$alpha_deg, 360, $black);
      imageArc($img, $xO, $yO, $D, $D, 0, $alpha_deg, $black);
      // arc pour alpha
      imageArc($img, $xO, $yO, $R, $R, 360-$alpha_deg, 360, $black); 
      imagettftext($img, $fs, 0, $xO+4+$R*cos($alpha/2)/2, $yO-$R*sin($alpha/2)/2, $black, $font2, "a"); // alpha
      
      // Dessin des chevrons
      $color = imagecolorallocate($img, 245, 247, 61);
      $values = array(
        $xC,$yC,
        $xA,$yA,
        $xA,$yA+$th,
        $xC,$yC+$th
      );
      imagefilledpolygon($img, $values, 4, $grey);
      //
      $values = array(
        $xH2,$yH2-$th/2,
        $xI,$yI-$th/2,
        $xI,$yI+$th/2,
        $xH2,$yH2+$th/2
      );
      imagefilledpolygon($img, $values, 4, $grey);
      $values = array(
        $xD,$yD,
        $xB,$yB,
        $xB,$yB-$th,
        $xD,$yD-$th
      );
      imagefilledpolygon($img, $values, 4, $grey);
      //
      // Dessin des lignes pointille
      $style = array($black, $black, $black, $black, $black, $white, $white, $white, $white, $white);
      imagesetstyle($img, $style);
      
      // Dessin des mesures
      // Z1, Z2, Z3 : points tmp
      $l1 = 25; // distance entre la figure et le point
      $l2 = 10; // depassement
      $l3 = 3; // espace entre ligne et texte
      $style = array($black, $black, $black, $white, $white, $white);
      imagesetstyle($img, $style);
      // ligne CA
      $xZ1 = $xC - $l1*sin($alpha);
      $yZ1 = $yC - $l1*cos($alpha);
      $xZ2 = $xA - $l1*sin($alpha);
      $yZ2 = $yA - $l1*cos($alpha);
      imageLine($img, $xZ1, $yZ1, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en C pour CA
      $xZ2 = $xC - ($l1+$l2)*sin($alpha);
      $yZ2 = $yC - ($l1+$l2)*cos($alpha);
      imageLine($img, $xC, $yC, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en A pour CA
      $xZ2 = $xA - ($l1+$l2)*sin($alpha);
      $yZ2 = $yA - ($l1+$l2)*cos($alpha);
      imageLine($img, $xA, $yA, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // mesure CA
      $xZ1 = $xC - ($l1+$l2+$l3)*sin($alpha);
      $yZ1 = $yC - ($l1+$l2+$l3)*cos($alpha);
      $xZ2 = $xA - ($l1+$l2+$l3)*sin($alpha);
      $yZ2 = $yA - ($l1+$l2+$l3)*cos($alpha);
      $xZ3 = ($xZ1 + $xZ2) / 2;
      $yZ3 = ($yZ1 + $yZ2) / 2;
      imagettftext($img, $fs3, $alpha_deg, $xZ3, $yZ3, $black, $font, round($CA / $scale, 1));
      //
      // limite en C pour CD
      $xZ2 = $xC - ($l1+$l2+$l3);
      $yZ2 = $yC;
      imageLine($img, $xC, $yC, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en D pour CD
      $xZ2 = $xD - ($l1+$l2+$l3);
      $yZ2 = $yD;
      imageLine($img, $xD, $yD, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // ligne CD
      $xZ1 = $xD - $l1;
      $yZ1 = $yD;
      $xZ2 = $xC - $l1;
      $yZ2 = $yC;
      imageLine($img, $xZ1, $yZ1, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // mesure CD
      $xZ1 = $xC - ($l1+$l2);
      $yZ1 = $yC;
      $xZ2 = $xD - ($l1+$l2);
      $yZ2 = $yD;
      $xZ3 = ($xZ1 + $xZ2) / 2;
      $yZ3 = ($yZ1 + $yZ2) / 2 + $fs3;
      imagettftext($img, $fs3, 90, $xZ3, $yZ3, $black, $font, round($CD / $scale, 1));
      
      //
      // ligne AB
      $xZ1 = $xI + 2*$l1;
      $yZ1 = $yA;
      $xZ2 = $xI + 2*$l1;
      $yZ2 = $yB;
      imageLine($img, $xZ1, $yZ1, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // ligne AI
      $xZ1 = $xI + $l1;
      $yZ1 = $yA;
      $xZ2 = $xI + $l1;
      $yZ2 = $yI;
      imageLine($img, $xZ1, $yZ1, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en A
      $xZ2 = $xI + (2*$l1+$l2);
      $yZ2 = $yA;
      imageLine($img, $xA, $yA, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en B
      $xZ2 = $xI + (2*$l1+$l2);
      $yZ2 = $yB;
      imageLine($img, $xB, $yB, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en I
      $xZ2 = $xI + ($l1+$l2);
      $yZ2 = $yI;
      imageLine($img, $xI, $yI, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // mesure AB
      $xZ1 = $xI + (2*$l1+$l2);
      $yZ1 = $yA + ($l1+$l3)-40;
      $xZ2 = $xI + (2*$l1+$l2);
      $yZ2 = $yB + ($l1+$l3)-40;
      $xZ3 = ($xZ1 + $xZ2) / 2;
      $yZ3 = ($yZ1 + $yZ2) / 2;
      imagettftext($img, $fs3, -90, $xZ3, $yZ3, $black, $font, round($AB / $scale, 1));
      // mesure AI
      $xZ1 = $xI + ($l1+$l2);
      $yZ1 = $yA + ($l1+$l3)-40;
      $xZ2 = $xI + ($l1+$l2);
      $yZ2 = $yI + ($l1+$l3)-40;
      $xZ3 = ($xZ1 + $xZ2) / 2;
      $yZ3 = ($yZ1 + $yZ2) / 2;
      imagettftext($img, $fs3, -90, $xZ3, $yZ3, $black, $font, round(($AB/2) / $scale, 1));
      //
      // limite en B
      $xZ2 = $xB;
      $yZ2 = $yB + $l1 + $l2;
      imageLine($img, $xB, $yB, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // limite en I
      $xZ2 = $xI;
      $yZ2 = $yB + $l1 + $l2;
      imageLine($img, $xI, $yI, $xZ2, $yZ2, IMG_COLOR_STYLED);
      // mesures
      $yZ1 = $yB + $l1 + $l3 + $fs3;
      $yZ2 = $yB + $l1 + $l3 + $fs3;
      // mesure H1I
      $xZ1 = $xB - 10;
      $xZ2 = $xI - 10;
      $xZ3 = ($xZ1 + $xZ2) / 2;
      $yZ3 = ($yZ1 + $yZ2) / 2;
      imagettftext($img, $fs3, 0, $xZ3, $yZ3, $black, $font, round($H1I / $scale, 1));
      // on change de ligne
      $yZ1 = $yB + 2*$l1 + $l3 + $fs3;
      $yZ2 = $yB + 2*$l1 + $l3 + $fs3;
      
      
      // dessin des lettres
      $colText = $black;
      imagettftext($img, $fs, 0, $xO-$fs-3, $yO+$fs/2, $colText, $font, "O");
      imagettftext($img, $fs, 0, $xA-$fs/2, $yA-3, $colText, $font, "A");
      imagettftext($img, $fs, 0, $xB-$fs/2, $yB+$fs+3, $colText, $font, "B");
      imagettftext($img, $fs, 0, $xC-$fs/2, $yC-3, $colText, $font, "C");
      imagettftext($img, $fs, 0, $xD-$fs/2, $yD+$fs+3, $colText, $font, "D");
      imagettftext($img, $fs, 0, $xE-$fs/2, $yE-3, $colText, $font, "E");
      imagettftext($img, $fs, 0, $xF-$fs/2, $yF+$fs+3, $colText, $font, "F");
      imagettftext($img, $fs, 0, $xI+3, $yI, $colText, $font, "I");
      //
      imagettftext($img, $fs, 0, $xH1-$fs-$fs2, $yH1-1-$th, $colText, $font, "H");
      imagettftext($img, $fs2, 0, $xH1-$fs+2, $yH1-1-$th, $colText, $font, "1");
      //
      imagettftext($img, $fs, 0, $xH3-$fs-$fs2, $yH3-1, $colText, $font, "H");
      imagettftext($img, $fs2, 0, $xH3-$fs+2, $yH3-1, $colText, $font, "3");
      //
      imagettftext($img, $fs, 0, $xH2-$fs-$fs2, $yH2-1, $colText, $font, "H");
      imagettftext($img, $fs2, 0, $xH2-$fs+2, $yH2-1, $colText, $font, "2");
      
      // dessin des points
      imagefilledellipse($img, $xO, $yO, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xA, $yA, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xB, $yB, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xC, $yC, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xD, $yD, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xE, $yE, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xF, $yF, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xI, $yI, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xH1, $yH1, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xH2, $yH2, $pointSize, $pointSize, $black);
      imagefilledellipse($img, $xH3, $yH3, $pointSize, $pointSize, $black);
      //
      return $img;
    }
  }// end toHtml
  
}// end class Floor
?>