<?php
// Software released under the General Public License (version 2 or later), available at
// http://www.gnu.org/copyleft/gpl.html
//********************************************************************************
/**
Variables generales de la yourte

@license  GPL
@author   <a href='http://www.tig12.net'>Thierry Graff</a>
@php      PHP5
@history 2007.03.13 : Creation
@history 2007.06.12 : transformation to a class
@history 2007.08.23 : debug
****************************************************************************************/
require_once(dirname(dirname(__FILE__)) . '/YurtPart.php');

class General extends YurtPart{
  
  public function toHtml($params = ''){
    // Valeurs a fixer a cette etape
    $D = $this->yurt->getConfig('general', 'D'); // diametre de la yourte, en m
    $h = $this->yurt->getConfig('general', 'h'); // hauteur des murs au treillis, en m
    $pt = $this->yurt->getConfig('general', 'pt'); // pente du toit, en pourcentage
    $dc = $this->yurt->getConfig('general', 'dc'); // diametre de la couronne, en m
    $np = $this->yurt->getConfig('general', 'np'); // nombre de perches
    $eiv = $this->yurt->getConfig('general', 'eiv'); // epaisseur de l'isolant vertical, en m
    $eit = $this->yurt->getConfig('general', 'eit'); // epaisseur de l'isolant du toit, en m
    
    // *** Calculs ***
    $R = $D / 2;
    $rc = $dc / 2;          // couronne
    $S = M_PI * $R * $R;    
    $p = 2 * M_PI * $R;     
    $alpha = atan($pt/100);
    $hp = ($R-$rc)*$pt/100; // h'
    $hs = $h + $hp;         // h''
    $V1 = $S * $h;
    $V2 = $S * $hp / 2;
    $V = $V1 + $V2;
    //
    $res = '';
    $res .= "<table>\n";
    $res .= "<tr><th colspan='2'>G&eacute;n&eacute;ral</th></tr>\n";
    $res .= "<tr><td>Diam&egrave;tre</td><td><b>D = " . self::formatMeters($D) . "</b></td></tr>\n";
    $res .= "<tr><td>Rayon</td><td><b>R = " . self::formatMeters($R) . "</b></td></tr>\n";
    $res .= "<tr><td>P&eacute;rim&egrave;tre</td><td><b>p = " . self::formatMeters($p) . "</b></td></tr>\n";
    $res .= "<tr><td>Surface au sol</td><td><b>S = " . round($S, 2) . " m<sup>2</sup></b></td></tr>\n";
    $res .= "<tr><td>Diam&egrave;tre couronne</td><td><b>dc = " . self::formatMeters($dc) . "</b></td></tr>\n";
    $res .= "<tr><td>Nombre de perches</td><td><b>np = " . $np . "</b></td></tr>\n";
    //
    $res .= "<tr><th colspan='2'>Volumes</th></tr>\n";
    $res .= "<tr><td>Du plancher au haut des murs</td><td><b>V<sub>1</sub> = " . round($V1, 1) . " m<sup>3</sup></b></td></tr>\n";
    $res .= "<tr><td>Du haut des murs au toit</td><td><b>V<sub>2</sub> = " . round($V2, 1) . " m<sup>3</sup></b></td></tr>\n";
    $res .= "<tr><td>Volume total</td><td><b>V = " . round($V, 1) . " m<sup>3</sup></b></td></tr>\n";
    //
    $res .= "<tr><th colspan='2'>Toit</th></tr>\n";
    $res .= "<tr><td>Pente du toit</td><td><b>pt = $pt %</b></td></tr>\n";
    $res .= "<tr><td>Angle du toit</td><td>
             <b>&alpha; = " . round($alpha*180/M_PI, 1) . " &deg;</b>
             <br/>&nbsp;&nbsp; = " . $alpha . " radians</b>
             </td></tr>\n";
    $res .= "<tr><td>Diam&egrave;tre toile du toit</td><td><b>pt = $pt %</b></td></tr>\n";
    //
    $res .= "<tr><th colspan='2'>Hauteurs</th></tr>\n";
    $res .= "<tr><td>Hauteur des murs</td><td><b>h = " . self::formatMeters($h) . "</b></td></tr>\n";
    $res .= "<tr><td>Hauteur du toit</td><td><b>h' = " . self::formatMeters($hp) . "</b></td></tr>\n";
    $res .= "<tr><td>Hauteur totale</td><td><b>h'' = " . self::formatMeters($hs) . "</b></td></tr>\n";
    //
    $res .= "<tr><th colspan='2'>Isolant</th></tr>\n";
    $res .= "<tr><td>Epaisseur isolant vertical</td><td><b>eiv = " . self::m2cm($eiv) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Epaisseur isolant toit</td><td><b>eit = " . self::m2cm($eit) . " cm</b></td></tr>\n";
    $res .= "</table>\n";
    return $res;
  }// end toHtml
  
}// end class General
?>