<?php
// Software released under the General Public License (version 2 or later), available at
// http://www.gnu.org/copyleft/gpl.html
//********************************************************************************
/**
Calculs li&eacute;s &agrave; la couture de la toile du toit ;
couvre de la couronne au haut des murs, goutti&egrave;re comprise.

@licence GPL
@author   <a href='http://www.tig12.net'>Thierry Graff</a>
@php      PHP5
@history 2007.09.08 : transformation to a class
****************************************************************************************/

require_once(dirname(dirname(__FILE__)) . '/YurtPart.php');

class Roof extends YurtPart{
  
  public function toHtml($params=''){
//echo "<pre>"; var_dump($params);; echo "</pre>";
    // Variables importees
    $D = $this->yurt->getConfig('general', 'D'); // diametre de la yourte
    $alpha = $this->yurt->getConfig('general', 'alpha'); // radians - pente du toit
    $lpc = $this->yurt->getConfig('crown', 'lpc'); // ~longueur de perche dans couronne, en m ; voir couronne
    $dc = $this->yurt->getConfig('general', 'dc');// rayon de la couronne, en m
    $rc = $dc / 2;
    $lp = $this->yurt->getResults('poles', 'lp'); // longueur des perches, en m
    //
    $Dp = $D / cos($alpha);                 // D' = 2*R' - Diametre de la toile du toit a plat
    //
    // toile disponible
    $wtt = $this->yurt->getConfig('linen_roof', 'wtt'); // largeur toile toit, en m
    $wttu = $this->yurt->getConfig('linen_roof', 'wttu'); // largeur toile toit utile (ourlets deduits), en m
    $gtt = $this->yurt->getConfig('linen_roof', 'gtt'); // poids de la toile, en g / m
    $cam = $this->yurt->getConfig('linen_roof', 'cam'); // cout au metre, en euros
    //
    // toile du toit
    $ltth = $this->yurt->getConfig('linen_roof', 'ltth'); // depassement toile en haut, en m
    $lttb = $this->yurt->getConfig('linen_roof', 'lttb'); // depassement toile en bas, en m
    
    // calculs
    // generalites
    $ltt1 = $lp - $lpc;
    $ltt = $ltt1 + $ltth + $lttb;
    $rtth = $rc - $ltth * cos($alpha);
    $rtt2 = $ltt * cos($alpha) + $rtth;
    $ltt2 = $rtth / cos($alpha);
    $rtt = $ltt + $ltt2;
    $dtt = 2 * $rtt;
    $beta = 2 * M_PI * cos($alpha);
    // Toile 1 : pi&egrave;ce de tissus
    $nbtt = $dtt / $wttu;
    $l1 = $dtt;
    $phi2 = acos($wttu / (2 * $rtt));
    $l2 = $dtt * sin($phi2);
    $phi3 = acos(3 * $wttu / (2 * $rtt));
    $l3 = $dtt * sin($phi3);
    $phi4 = acos(5 * $wttu / (2 * $rtt));
    $l4 = $dtt * sin($phi4);
    //
    $delta1 = ($l1 - $l2) / 2;
    $delta2 = ($l2 - $l3) / 2;
    $delta3 = ($l3 - $l4) / 2;
    $AB = 2 * $rtt * sin($beta/2);
    // Affichage des resultats
    $res = '';
    $res .= "<table>\n";
    //
    $res .= "<tr><th colspan='2'><b>Variables import&eacute;es</b></th></tr>\n";
    $res .= "<tr><td>Diam&egrave;tre de la yourte</td><td><b>&alpha; = " . $D . " m</b></td></tr>\n";
    $res .= "<tr><td>Angle du toit</td><td><b>&alpha; = " . round($alpha*180/M_PI) . " &deg;</b></td></tr>\n";
    $res .= "<tr><td>Longueur des perches</td><td><b>lp = " . round($lp, 2) . " m</b></td></tr>\n";
    $res .= "<tr><td>Rayon de la couronne</td><td><b>rp = " . round($rc, 2) . " m</b></td></tr>\n";
    $res .= "<tr><td>Longueur de perche dans couronne</td><td><b>lpc = " . round(self::m2cm($lpc)) . " cm</b></td></tr>\n";
    //
    $res .= "<tr><th colspan='2'>G&eacute;n&eacute;ralit&eacute;s</th></tr>\n";
    $res .= "<tr><td>Diam&egrave;tre brut de la toile &agrave; plat</td><td><b>D' = " . round($Dp, 2) . " m</b></td></tr>\n";
    $res .= "<tr><td>Angle occup&eacute; par la toile</td><td><b>&beta; = " . round($beta*180/M_PI) . " &deg;</b></td></tr>\n";
    $res .= "<tr><td>Voir figure</td><td><b>ltt1 = " . round(self::m2cm($ltt1)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Longueur toile toit</td><td><b>ltt = " . round(self::m2cm($ltt)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Voir figure</td><td><b>rtth = " . round(self::m2cm($rtth)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Voir figure</td><td><b>rtt2 = " . round(self::m2cm($rtt2)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Voir figure</td><td><b>ltt2 = " . round(self::m2cm($ltt2)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Voir figure</td><td><b>rtt = " . round(self::m2cm($rtt)) . " cm</b></td></tr>\n";
    //
    $res .= "<tr><th colspan='2'>Pi&egrave;ce de tissus</th></tr>\n";
    $res .= "<tr><td>Nombre de pi&egrave;ces</td><td><b>npt = " . round($nbtt, 2) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Longueur bande 1</td><td><b>l1 = " . round(self::m2cm($l1)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Longueur bande 2</td><td><b>l2 = " . round(self::m2cm($l2)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Longueur bande 3</td><td><b>l3 = " . round(self::m2cm($l3)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>Longueur bande 4</td><td><b>l4 = " . round(self::m2cm($l4)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>D&eacute;calage 1</td><td><b>&delta;1 = " . round(self::m2cm($delta1)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>D&eacute;calage 2</td><td><b>&delta;2 = " . round(self::m2cm($delta2)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>D&eacute;calage 3</td><td><b>&delta;3 = " . round(self::m2cm($delta3)) . " cm</b></td></tr>\n";
    $res .= "<tr><td>D&eacute;coupe de &beta;</td><td><b>AB = " . round(self::m2cm($AB)) . " cm</b></td></tr>\n";
    $res.= "</table>\n";
    return $res;
  }// end toHtml
  
}// end class Roof
?>